-- GLOBALS
Global( "UNITS", {} )

-- EVENT HANDLERS
function onSpawned( params )
	if unit.IsPlayer( params.unitId ) and not unit.IsFriend(  params.unitId ) then
		UNITS[params.unitId] = 1
	end
end

function onDespawned( params )
	if UNITS[params.unitId] then UNITS[params.unitId] = nil end
end

function OnDead( params )
	if UNITS[params.unitId]  then
	   	if object.IsDead(params.unitId) then
	   		UNITS[params.unitId] = nil		
	   	end
	else
		if not object.IsDead(params.unitId) then onSpawned({unitId = params.unitId}) end
	end
end

function OnTimer( params )
  if not avatar.GetTarget() then
	local Me = avatar.GetId()
	   for i in  UNITS do
		
		if object.IsExist( i ) then
			local T = unit.GetTarget( i )
			if T == Me then
				if UNITS[i] == 1 then
					if not unit.GetTarget( Me ) then 
						avatar.SelectTarget(i)
						UNITS[i] = 3
					else
						UNITS[i] = 2
					end
				end ----!! +mess !!
			else
		   		if UNITS[i] == 3 then UNITS[i] = 1 end
			end
		else
			UNITS[i] = nil
		end
	 end
  end
end

function onAvatarCreated()
	common.RegisterEventHandler( OnTimer, "EVENT_SECOND_TIMER" )
end

function OnMem( params )
    userMods.SendEvent( "U_EVENT_ADDON_MEM_USAGE_RESPONSE", { sender = common.GetAddonName(), memUsage = gcinfo() } )
end
-- INITIALIZATION

function Init()
 	common.RegisterEventHandler(onSpawned, "EVENT_UNIT_SPAWNED" )
	common.RegisterEventHandler(onDespawned, "EVENT_UNIT_DESPAWNED" )
 	common.RegisterEventHandler( onAvatarCreated, "EVENT_AVATAR_CREATED" )
 	common.RegisterEventHandler( OnDead, "EVENT_UNIT_DEAD_CHANGED" )
	common.RegisterEventHandler( OnMem, "U_EVENT_ADDON_MEM_USAGE_REQUEST")
end

Init()
